// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 36 "src/parser.yy"

#include <iostream>

#include "driver.h"
#include "lexer.h"

void yyerror(bpftrace::Driver &driver, const char *s);

#line 50 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"


#include "parser.tab.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 4 "src/parser.yy"
namespace  bpftrace  {
#line 148 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"

  /// Build a parser object.
  Parser::Parser (bpftrace::Driver &driver_yyarg, void *yyscanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

  Parser::~Parser ()
  {}

  Parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/



  // by_state.
  Parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  Parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  Parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  Parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  Parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  Parser::symbol_kind_type
  Parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  Parser::stack_symbol_type::stack_symbol_type ()
  {}

  Parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.YY_MOVE_OR_COPY< SizedType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.YY_MOVE_OR_COPY< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.YY_MOVE_OR_COPY< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.YY_MOVE_OR_COPY< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.YY_MOVE_OR_COPY< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.YY_MOVE_OR_COPY< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.YY_MOVE_OR_COPY< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.YY_MOVE_OR_COPY< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.YY_MOVE_OR_COPY< ast::Offsetof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.YY_MOVE_OR_COPY< ast::Operator > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.YY_MOVE_OR_COPY< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.YY_MOVE_OR_COPY< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.YY_MOVE_OR_COPY< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.YY_MOVE_OR_COPY< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.YY_MOVE_OR_COPY< ast::Sizeof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.YY_MOVE_OR_COPY< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.YY_MOVE_OR_COPY< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.YY_MOVE_OR_COPY< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_SIMPLE_TYPE: // "simple type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  Parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.move< SizedType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.move< ast::Offsetof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< ast::Operator > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.move< ast::Sizeof * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_SIMPLE_TYPE: // "simple type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.copy< SizedType > (that.value);
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.copy< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.copy< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.copy< ast::Call * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.copy< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.copy< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.copy< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.copy< ast::Map * > (that.value);
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.copy< ast::Offsetof * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.copy< ast::Operator > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.copy< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.copy< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.copy< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.copy< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.copy< ast::Sizeof * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.copy< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.copy< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.copy< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.copy< int64_t > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_SIMPLE_TYPE: // "simple type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  Parser::stack_symbol_type&
  Parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        value.move< SizedType > (that.value);
        break;

      case symbol_kind::S_attach_point: // attach_point
        value.move< ast::AttachPoint * > (that.value);
        break;

      case symbol_kind::S_attach_points: // attach_points
        value.move< ast::AttachPointList * > (that.value);
        break;

      case symbol_kind::S_call: // call
        value.move< ast::Call * > (that.value);
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        value.move< ast::Expression * > (that.value);
        break;

      case symbol_kind::S_vargs: // vargs
        value.move< ast::ExpressionList * > (that.value);
        break;

      case symbol_kind::S_int: // int
        value.move< ast::Integer * > (that.value);
        break;

      case symbol_kind::S_map: // map
        value.move< ast::Map * > (that.value);
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        value.move< ast::Offsetof * > (that.value);
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        value.move< ast::Operator > (that.value);
        break;

      case symbol_kind::S_param: // param
        value.move< ast::PositionalParameter * > (that.value);
        break;

      case symbol_kind::S_pred: // pred
        value.move< ast::Predicate * > (that.value);
        break;

      case symbol_kind::S_probe: // probe
        value.move< ast::Probe * > (that.value);
        break;

      case symbol_kind::S_probes: // probes
        value.move< ast::ProbeList * > (that.value);
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        value.move< ast::Sizeof * > (that.value);
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        value.move< ast::Statement * > (that.value);
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        value.move< ast::StatementList * > (that.value);
        break;

      case symbol_kind::S_var: // var
        value.move< ast::Variable * > (that.value);
        break;

      case symbol_kind::S_INT: // "integer"
        value.move< int64_t > (that.value);
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_SIMPLE_TYPE: // "simple type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  Parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  Parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  Parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  Parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  Parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  Parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  Parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  Parser::debug_level_type
  Parser::debug_level () const
  {
    return yydebug_;
  }

  void
  Parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  Parser::state_type
  Parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  Parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  Parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  Parser::operator() ()
  {
    return parse ();
  }

  int
  Parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_type: // type
      case symbol_kind::S_pointer_type: // pointer_type
      case symbol_kind::S_struct_type: // struct_type
        yylhs.value.emplace< SizedType > ();
        break;

      case symbol_kind::S_attach_point: // attach_point
        yylhs.value.emplace< ast::AttachPoint * > ();
        break;

      case symbol_kind::S_attach_points: // attach_points
        yylhs.value.emplace< ast::AttachPointList * > ();
        break;

      case symbol_kind::S_call: // call
        yylhs.value.emplace< ast::Call * > ();
        break;

      case symbol_kind::S_primary_expr: // primary_expr
      case symbol_kind::S_postfix_expr: // postfix_expr
      case symbol_kind::S_tuple_access_expr: // tuple_access_expr
      case symbol_kind::S_unary_expr: // unary_expr
      case symbol_kind::S_expr: // expr
      case symbol_kind::S_conditional_expr: // conditional_expr
      case symbol_kind::S_logical_or_expr: // logical_or_expr
      case symbol_kind::S_logical_and_expr: // logical_and_expr
      case symbol_kind::S_or_expr: // or_expr
      case symbol_kind::S_xor_expr: // xor_expr
      case symbol_kind::S_and_expr: // and_expr
      case symbol_kind::S_equality_expr: // equality_expr
      case symbol_kind::S_relational_expr: // relational_expr
      case symbol_kind::S_shift_expr: // shift_expr
      case symbol_kind::S_muli_expr: // muli_expr
      case symbol_kind::S_addi_expr: // addi_expr
      case symbol_kind::S_cast_expr: // cast_expr
      case symbol_kind::S_map_or_var: // map_or_var
        yylhs.value.emplace< ast::Expression * > ();
        break;

      case symbol_kind::S_vargs: // vargs
        yylhs.value.emplace< ast::ExpressionList * > ();
        break;

      case symbol_kind::S_int: // int
        yylhs.value.emplace< ast::Integer * > ();
        break;

      case symbol_kind::S_map: // map
        yylhs.value.emplace< ast::Map * > ();
        break;

      case symbol_kind::S_offsetof_expr: // offsetof_expr
        yylhs.value.emplace< ast::Offsetof * > ();
        break;

      case symbol_kind::S_unary_op: // unary_op
      case symbol_kind::S_compound_op: // compound_op
        yylhs.value.emplace< ast::Operator > ();
        break;

      case symbol_kind::S_param: // param
        yylhs.value.emplace< ast::PositionalParameter * > ();
        break;

      case symbol_kind::S_pred: // pred
        yylhs.value.emplace< ast::Predicate * > ();
        break;

      case symbol_kind::S_probe: // probe
        yylhs.value.emplace< ast::Probe * > ();
        break;

      case symbol_kind::S_probes: // probes
        yylhs.value.emplace< ast::ProbeList * > ();
        break;

      case symbol_kind::S_sizeof_expr: // sizeof_expr
        yylhs.value.emplace< ast::Sizeof * > ();
        break;

      case symbol_kind::S_block_stmt: // block_stmt
      case symbol_kind::S_expr_stmt: // expr_stmt
      case symbol_kind::S_jump_stmt: // jump_stmt
      case symbol_kind::S_loop_stmt: // loop_stmt
      case symbol_kind::S_if_stmt: // if_stmt
      case symbol_kind::S_assign_stmt: // assign_stmt
        yylhs.value.emplace< ast::Statement * > ();
        break;

      case symbol_kind::S_block: // block
      case symbol_kind::S_stmt_list: // stmt_list
      case symbol_kind::S_block_or_if: // block_or_if
        yylhs.value.emplace< ast::StatementList * > ();
        break;

      case symbol_kind::S_var: // var
        yylhs.value.emplace< ast::Variable * > ();
        break;

      case symbol_kind::S_INT: // "integer"
        yylhs.value.emplace< int64_t > ();
        break;

      case symbol_kind::S_BUILTIN: // "builtin"
      case symbol_kind::S_CALL: // "call"
      case symbol_kind::S_CALL_BUILTIN: // "call_builtin"
      case symbol_kind::S_SIMPLE_TYPE: // "simple type"
      case symbol_kind::S_SIZED_TYPE: // "sized type"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_PATH: // "path"
      case symbol_kind::S_CPREPROC: // "preprocessor directive"
      case symbol_kind::S_STRUCT_DEFN: // "struct definition"
      case symbol_kind::S_ENUM: // "enum"
      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_MAP: // "map"
      case symbol_kind::S_VAR: // "variable"
      case symbol_kind::S_PARAM: // "positional parameter"
      case symbol_kind::S_STACK_MODE: // "stack_mode"
      case symbol_kind::S_c_definitions: // c_definitions
      case symbol_kind::S_attach_point_def: // attach_point_def
      case symbol_kind::S_ident: // ident
        yylhs.value.emplace< std::string > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // program: c_definitions probes "end of file"
#line 171 "src/parser.yy"
                                         { driver.root = std::make_unique<ast::Program>(yystack_[2].value.as < std::string > (), yystack_[1].value.as < ast::ProbeList * > ()); }
#line 1163 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 3: // c_definitions: "preprocessor directive" c_definitions
#line 175 "src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\n" + yystack_[0].value.as < std::string > (); }
#line 1169 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 4: // c_definitions: "struct" "struct definition" c_definitions
#line 176 "src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1175 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 5: // c_definitions: "struct" "enum" c_definitions
#line 177 "src/parser.yy"
                                                 { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ";\n" + yystack_[0].value.as < std::string > (); }
#line 1181 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 6: // c_definitions: %empty
#line 178 "src/parser.yy"
                                                 { yylhs.value.as < std::string > () = std::string(); }
#line 1187 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 7: // type: "simple type"
#line 182 "src/parser.yy"
                            {
                    static std::unordered_map<std::string, SizedType> type_map = {
                        {"bool", CreateBool()},
                        {"uint8", CreateUInt(8)},
                        {"uint16", CreateUInt(16)},
                        {"uint32", CreateUInt(32)},
                        {"uint64", CreateUInt(64)},
                        {"int8", CreateInt(8)},
                        {"int16", CreateInt(16)},
                        {"int32", CreateInt(32)},
                        {"int64", CreateInt(64)},
                        {"min_t", CreateMin(true)},
                        {"max_t", CreateMax(true)},
                        {"sum_t", CreateSum(true)},
                        {"count_t", CreateCount(true)},
                        {"avg_t", CreateAvg(true)},
                        {"stats_t", CreateStats(true)},
                        {"umin_t", CreateMin(false)},
                        {"umax_t", CreateMax(false)},
                        {"usum_t", CreateSum(false)},
                        {"ucount_t", CreateCount(false)},
                        {"uavg_t", CreateAvg(false)},
                        {"ustats_t", CreateStats(false)},
                        {"timestamp_t", CreateTimestamp()},
                        {"macaddr_t", CreateMacAddress()},
                        {"cgroup_path_t", CreateCgroupPath()},
                        {"strerror_t", CreateStrerror()},
                    };
                    yylhs.value.as < SizedType > () = type_map[yystack_[0].value.as < std::string > ()];
                }
#line 1222 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 8: // type: "sized type" "[" "integer" "]"
#line 212 "src/parser.yy"
                                       {
                    if (yystack_[3].value.as < std::string > () == "str_t") {
                        yylhs.value.as < SizedType > () = CreateString(yystack_[1].value.as < int64_t > ());
                    } else if (yystack_[3].value.as < std::string > () == "inet_t") {
                        yylhs.value.as < SizedType > () = CreateInet(yystack_[1].value.as < int64_t > ());
                    } else if (yystack_[3].value.as < std::string > () == "buf_t") {
                        yylhs.value.as < SizedType > () = CreateBuffer(yystack_[1].value.as < int64_t > ());
                    }
                }
#line 1236 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 9: // type: pointer_type
#line 221 "src/parser.yy"
                             { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1242 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 10: // type: struct_type
#line 222 "src/parser.yy"
                            { yylhs.value.as < SizedType > () = yystack_[0].value.as < SizedType > (); }
#line 1248 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 11: // pointer_type: type "*"
#line 226 "src/parser.yy"
                         { yylhs.value.as < SizedType > () = CreatePointer(yystack_[1].value.as < SizedType > ()); }
#line 1254 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 12: // struct_type: "struct" "identifier"
#line 229 "src/parser.yy"
                             { yylhs.value.as < SizedType > () = ast::ident_to_record(yystack_[0].value.as < std::string > ()); }
#line 1260 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 13: // probes: probes probe
#line 233 "src/parser.yy"
                             { yylhs.value.as < ast::ProbeList * > () = yystack_[1].value.as < ast::ProbeList * > (); yystack_[1].value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1266 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 14: // probes: probe
#line 234 "src/parser.yy"
                             { yylhs.value.as < ast::ProbeList * > () = new ast::ProbeList; yylhs.value.as < ast::ProbeList * > ()->push_back(yystack_[0].value.as < ast::Probe * > ()); }
#line 1272 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 15: // probe: attach_points pred block
#line 239 "src/parser.yy"
                {
                  if (!driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[2].value.as < ast::AttachPointList * > (), yystack_[1].value.as < ast::Predicate * > (), yystack_[0].value.as < ast::StatementList * > ());
                  else
                  {
                    error(yylhs.location, "unexpected listing query format");
                    YYERROR;
                  }
                }
#line 1286 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 16: // probe: attach_points "end of file"
#line 249 "src/parser.yy"
                {
                  if (driver.listing_)
                    yylhs.value.as < ast::Probe * > () = new ast::Probe(yystack_[1].value.as < ast::AttachPointList * > (), nullptr, nullptr);
                  else
                  {
                    error(yylhs.location, "unexpected end of file, expected {");
                    YYERROR;
                  }
                }
#line 1300 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 17: // attach_points: attach_points "," attach_point
#line 261 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = yystack_[2].value.as < ast::AttachPointList * > (); yystack_[2].value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1306 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 18: // attach_points: attach_point
#line 262 "src/parser.yy"
                                               { yylhs.value.as < ast::AttachPointList * > () = new ast::AttachPointList; yylhs.value.as < ast::AttachPointList * > ()->push_back(yystack_[0].value.as < ast::AttachPoint * > ()); }
#line 1312 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 19: // attach_point: attach_point_def
#line 266 "src/parser.yy"
                                                { yylhs.value.as < ast::AttachPoint * > () = new ast::AttachPoint(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1318 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 20: // attach_point_def: attach_point_def ident
#line 270 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1324 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 21: // attach_point_def: attach_point_def "string"
#line 274 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "\"" + std::regex_replace(yystack_[0].value.as < std::string > (), std::regex("\""), "\\\"") + "\""; }
#line 1330 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 22: // attach_point_def: attach_point_def "path"
#line 275 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + yystack_[0].value.as < std::string > (); }
#line 1336 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 23: // attach_point_def: attach_point_def "integer"
#line 276 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + std::to_string(yystack_[0].value.as < int64_t > ()); }
#line 1342 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 24: // attach_point_def: attach_point_def ":"
#line 277 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + ":"; }
#line 1348 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 25: // attach_point_def: attach_point_def "."
#line 278 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "."; }
#line 1354 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 26: // attach_point_def: attach_point_def "+"
#line 279 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "+"; }
#line 1360 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 27: // attach_point_def: attach_point_def "*"
#line 280 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "*"; }
#line 1366 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 28: // attach_point_def: attach_point_def "["
#line 281 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "["; }
#line 1372 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 29: // attach_point_def: attach_point_def "]"
#line 282 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "]"; }
#line 1378 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 30: // attach_point_def: attach_point_def param
#line 284 "src/parser.yy"
                {
                  if (yystack_[0].value.as < ast::PositionalParameter * > ()->ptype != PositionalParameterType::positional)
                  {
                    error(yylhs.location, "Not a positional parameter");
                    YYERROR;
                  }
                  // "Un-parse" the positional parameter back into text so
                  // we can give it to the AttachPointParser. This is kind of
                  // a hack but there doesn't look to be any other way.
                  yylhs.value.as < std::string > () = yystack_[1].value.as < std::string > () + "$" + std::to_string(yystack_[0].value.as < ast::PositionalParameter * > ()->n);
                  delete yystack_[0].value.as < ast::PositionalParameter * > ();
                }
#line 1395 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 31: // attach_point_def: %empty
#line 296 "src/parser.yy"
                                          { yylhs.value.as < std::string > () = ""; }
#line 1401 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 32: // pred: "/" expr "end predicate"
#line 300 "src/parser.yy"
                                 { yylhs.value.as < ast::Predicate * > () = new ast::Predicate(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 1407 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 33: // pred: %empty
#line 301 "src/parser.yy"
                                  { yylhs.value.as < ast::Predicate * > () = nullptr; }
#line 1413 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 34: // param: "positional parameter"
#line 306 "src/parser.yy"
                      {
                        try {
                          long n = std::stol(yystack_[0].value.as < std::string > ().substr(1, yystack_[0].value.as < std::string > ().size()-1));
                          if (n == 0) throw std::exception();
                          yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::positional, n, yylhs.location);
                        } catch (std::exception const& e) {
                          error(yystack_[0].location, "param " + yystack_[0].value.as < std::string > () + " is out of integer range [1, " +
                                std::to_string(std::numeric_limits<long>::max()) + "]");
                          YYERROR;
                        }
                      }
#line 1429 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 35: // param: "$#"
#line 317 "src/parser.yy"
                           { yylhs.value.as < ast::PositionalParameter * > () = new ast::PositionalParameter(PositionalParameterType::count, 0, yylhs.location); }
#line 1435 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 36: // block: "{" stmt_list "}"
#line 321 "src/parser.yy"
                                      { yylhs.value.as < ast::StatementList * > () = yystack_[1].value.as < ast::StatementList * > (); }
#line 1441 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 37: // stmt_list: expr_stmt ";" stmt_list
#line 328 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[2].value.as < ast::Statement * > ()); }
#line 1447 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 38: // stmt_list: expr_stmt
#line 329 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->push_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1453 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 39: // stmt_list: block_stmt stmt_list
#line 333 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); yystack_[0].value.as < ast::StatementList * > ()->insert(yystack_[0].value.as < ast::StatementList * > ()->begin(), yystack_[1].value.as < ast::Statement * > ()); }
#line 1459 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 40: // stmt_list: %empty
#line 334 "src/parser.yy"
                                        { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; }
#line 1465 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 41: // block_stmt: loop_stmt
#line 338 "src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1471 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 42: // block_stmt: if_stmt
#line 339 "src/parser.yy"
                             { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1477 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 43: // expr_stmt: expr
#line 343 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = new ast::ExprStatement(yystack_[0].value.as < ast::Expression * > (), yystack_[0].location); }
#line 1483 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 44: // expr_stmt: jump_stmt
#line 344 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1489 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 45: // expr_stmt: assign_stmt
#line 349 "src/parser.yy"
                                   { yylhs.value.as < ast::Statement * > () = yystack_[0].value.as < ast::Statement * > (); }
#line 1495 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 46: // jump_stmt: "break"
#line 353 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::BREAK, yylhs.location); }
#line 1501 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 47: // jump_stmt: "continue"
#line 354 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::CONTINUE, yylhs.location); }
#line 1507 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 48: // jump_stmt: "return"
#line 355 "src/parser.yy"
                         { yylhs.value.as < ast::Statement * > () = new ast::Jump(ast::JumpType::RETURN, yylhs.location); }
#line 1513 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 49: // loop_stmt: "unroll" "(" int ")" block
#line 359 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::Integer * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1519 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 50: // loop_stmt: "unroll" "(" param ")" block
#line 360 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::Unroll(yystack_[2].value.as < ast::PositionalParameter * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location + yystack_[1].location); }
#line 1525 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 51: // loop_stmt: "while" "(" expr ")" block
#line 361 "src/parser.yy"
                                                     { yylhs.value.as < ast::Statement * > () = new ast::While(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > (), yystack_[4].location); }
#line 1531 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 52: // if_stmt: "if" "(" expr ")" block
#line 365 "src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1537 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 53: // if_stmt: "if" "(" expr ")" block "else" block_or_if
#line 366 "src/parser.yy"
                                                       { yylhs.value.as < ast::Statement * > () = new ast::If(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::StatementList * > (), yystack_[0].value.as < ast::StatementList * > ()); }
#line 1543 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 54: // block_or_if: block
#line 370 "src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = yystack_[0].value.as < ast::StatementList * > (); }
#line 1549 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 55: // block_or_if: if_stmt
#line 371 "src/parser.yy"
                             { yylhs.value.as < ast::StatementList * > () = new ast::StatementList; yylhs.value.as < ast::StatementList * > ()->emplace_back(yystack_[0].value.as < ast::Statement * > ()); }
#line 1555 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 56: // assign_stmt: tuple_access_expr "=" expr
#line 376 "src/parser.yy"
                {
                  error(yystack_[2].location + yystack_[0].location, "Tuples are immutable once created. Consider creating a new tuple and assigning it instead.");
                  YYERROR;
                }
#line 1564 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 57: // assign_stmt: map "=" expr
#line 380 "src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1570 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 58: // assign_stmt: var "=" expr
#line 381 "src/parser.yy"
                                     { yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), yystack_[0].value.as < ast::Expression * > (), false, yystack_[1].location); }
#line 1576 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 59: // assign_stmt: map compound_op expr
#line 383 "src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Map * > (), yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignMapStatement(yystack_[2].value.as < ast::Map * > (), b, true, yylhs.location);
                }
#line 1585 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 60: // assign_stmt: var compound_op expr
#line 388 "src/parser.yy"
                {
                  auto b = new ast::Binop(yystack_[2].value.as < ast::Variable * > (), yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location);
                  yylhs.value.as < ast::Statement * > () = new ast::AssignVarStatement(yystack_[2].value.as < ast::Variable * > (), b, true, yylhs.location);
                }
#line 1594 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 61: // primary_expr: "identifier"
#line 395 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Identifier(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1600 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 62: // primary_expr: int
#line 396 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Integer * > (); }
#line 1606 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 63: // primary_expr: "string"
#line 397 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::String(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1612 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 64: // primary_expr: "stack_mode"
#line 398 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::StackMode(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1618 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 65: // primary_expr: "builtin"
#line 399 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1624 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 66: // primary_expr: "call_builtin"
#line 400 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = new ast::Builtin(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1630 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 67: // primary_expr: "(" expr ")"
#line 401 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[1].value.as < ast::Expression * > (); }
#line 1636 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 68: // primary_expr: param
#line 402 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::PositionalParameter * > (); }
#line 1642 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 69: // primary_expr: map_or_var
#line 403 "src/parser.yy"
                                   { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1648 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 70: // primary_expr: "(" expr "," vargs ")"
#line 405 "src/parser.yy"
                {
                  auto args = new ast::ExpressionList;
                  args->emplace_back(yystack_[3].value.as < ast::Expression * > ());
                  args->insert(args->end(), yystack_[1].value.as < ast::ExpressionList * > ()->begin(), yystack_[1].value.as < ast::ExpressionList * > ()->end());
                  yylhs.value.as < ast::Expression * > () = new ast::Tuple(args, yylhs.location);
                }
#line 1659 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 71: // postfix_expr: primary_expr
#line 414 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1665 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 72: // postfix_expr: postfix_expr "." ident
#line 416 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < std::string > (), yystack_[1].location); }
#line 1671 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 73: // postfix_expr: postfix_expr "->" ident
#line 417 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(new ast::Unop(ast::Operator::MUL, yystack_[2].value.as < ast::Expression * > (), yystack_[1].location), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1677 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 74: // postfix_expr: tuple_access_expr
#line 419 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1683 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 75: // postfix_expr: postfix_expr "[" expr "]"
#line 421 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::ArrayAccess(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < ast::Expression * > (), yystack_[2].location + yystack_[0].location); }
#line 1689 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 76: // postfix_expr: call
#line 422 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Call * > (); }
#line 1695 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 77: // postfix_expr: sizeof_expr
#line 423 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Sizeof * > (); }
#line 1701 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 78: // postfix_expr: offsetof_expr
#line 424 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Offsetof * > (); }
#line 1707 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 79: // postfix_expr: map_or_var "++"
#line 425 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::INCREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1713 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 80: // postfix_expr: map_or_var "--"
#line 426 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::DECREMENT, yystack_[1].value.as < ast::Expression * > (), true, yystack_[0].location); }
#line 1719 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 81: // postfix_expr: "++" ident
#line 428 "src/parser.yy"
                                          { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1725 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 82: // postfix_expr: "--" ident
#line 429 "src/parser.yy"
                                          { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1731 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 83: // tuple_access_expr: postfix_expr "." "integer"
#line 434 "src/parser.yy"
                                          { yylhs.value.as < ast::Expression * > () = new ast::FieldAccess(yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < int64_t > (), yystack_[0].location); }
#line 1737 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 84: // unary_expr: unary_op cast_expr
#line 440 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(yystack_[1].value.as < ast::Operator > (), yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1743 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 85: // unary_expr: postfix_expr
#line 441 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1749 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 86: // unary_expr: "++" map_or_var
#line 442 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::INCREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1755 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 87: // unary_expr: "--" map_or_var
#line 443 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Unop(ast::Operator::DECREMENT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1761 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 88: // unary_expr: ident "--"
#line 445 "src/parser.yy"
                                     { error(yystack_[1].location, "The -- operator must be applied to a map or variable"); YYERROR; }
#line 1767 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 89: // unary_expr: ident "++"
#line 446 "src/parser.yy"
                                     { error(yystack_[1].location, "The ++ operator must be applied to a map or variable"); YYERROR; }
#line 1773 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 90: // unary_op: "*"
#line 450 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::MUL; }
#line 1779 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 91: // unary_op: "~"
#line 451 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::BNOT; }
#line 1785 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 92: // unary_op: "!"
#line 452 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::LNOT; }
#line 1791 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 93: // unary_op: "-"
#line 453 "src/parser.yy"
                       { yylhs.value.as < ast::Operator > () = ast::Operator::MINUS; }
#line 1797 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 94: // expr: conditional_expr
#line 457 "src/parser.yy"
                                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1803 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 95: // conditional_expr: logical_or_expr
#line 461 "src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1809 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 96: // conditional_expr: logical_or_expr "?" expr ":" conditional_expr
#line 462 "src/parser.yy"
                                                                 { yylhs.value.as < ast::Expression * > () = new ast::Ternary(yystack_[4].value.as < ast::Expression * > (), yystack_[2].value.as < ast::Expression * > (), yystack_[0].value.as < ast::Expression * > (), yylhs.location); }
#line 1815 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 97: // logical_or_expr: logical_and_expr
#line 467 "src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1821 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 98: // logical_or_expr: logical_or_expr "||" logical_and_expr
#line 468 "src/parser.yy"
                                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1827 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 99: // logical_and_expr: or_expr
#line 472 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1833 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 100: // logical_and_expr: logical_and_expr "&&" or_expr
#line 473 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1839 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 101: // or_expr: xor_expr
#line 477 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1845 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 102: // or_expr: or_expr "|" xor_expr
#line 478 "src/parser.yy"
                                     { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1851 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 103: // xor_expr: and_expr
#line 482 "src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1857 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 104: // xor_expr: xor_expr "^" and_expr
#line 483 "src/parser.yy"
                                       { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BXOR, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1863 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 105: // and_expr: equality_expr
#line 488 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1869 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 106: // and_expr: and_expr "&" equality_expr
#line 489 "src/parser.yy"
                                            { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::BAND, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1875 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 107: // equality_expr: relational_expr
#line 493 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1881 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 108: // equality_expr: equality_expr "==" relational_expr
#line 494 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::EQ, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1887 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 109: // equality_expr: equality_expr "!=" relational_expr
#line 495 "src/parser.yy"
                                                 { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::NE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1893 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 110: // relational_expr: shift_expr
#line 499 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1899 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 111: // relational_expr: relational_expr "<=" shift_expr
#line 500 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1905 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 112: // relational_expr: relational_expr ">=" shift_expr
#line 501 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::GE, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1911 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 113: // relational_expr: relational_expr "<" shift_expr
#line 502 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1917 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 114: // relational_expr: relational_expr ">" shift_expr
#line 503 "src/parser.yy"
                                              { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::GT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1923 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 115: // shift_expr: addi_expr
#line 507 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1929 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 116: // shift_expr: shift_expr "<<" addi_expr
#line 508 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::LEFT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1935 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 117: // shift_expr: shift_expr ">>" addi_expr
#line 509 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::RIGHT, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1941 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 118: // muli_expr: cast_expr
#line 513 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1947 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 119: // muli_expr: muli_expr "*" cast_expr
#line 514 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MUL, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1953 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 120: // muli_expr: muli_expr "/" cast_expr
#line 515 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::DIV, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1959 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 121: // muli_expr: muli_expr "%" cast_expr
#line 516 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MOD, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1965 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 122: // addi_expr: muli_expr
#line 520 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1971 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 123: // addi_expr: addi_expr "+" muli_expr
#line 521 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::PLUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1977 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 124: // addi_expr: addi_expr "-" muli_expr
#line 522 "src/parser.yy"
                                           { yylhs.value.as < ast::Expression * > () = new ast::Binop(yystack_[2].value.as < ast::Expression * > (), ast::Operator::MINUS, yystack_[0].value.as < ast::Expression * > (), yystack_[1].location); }
#line 1983 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 125: // cast_expr: unary_expr
#line 526 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Expression * > (); }
#line 1989 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 126: // cast_expr: "(" type ")" cast_expr
#line 527 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(yystack_[2].value.as < SizedType > (), yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 1995 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 127: // cast_expr: "(" "identifier" ")" cast_expr
#line 529 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(ast::ident_to_record(yystack_[2].value.as < std::string > (), 0), yystack_[0].value.as < ast::Expression * > (), yystack_[3].location + yystack_[1].location); }
#line 2001 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 128: // cast_expr: "(" "identifier" "*" ")" cast_expr
#line 530 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(ast::ident_to_record(yystack_[3].value.as < std::string > (), 1), yystack_[0].value.as < ast::Expression * > (), yystack_[4].location + yystack_[1].location); }
#line 2007 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 129: // cast_expr: "(" "identifier" "*" "*" ")" cast_expr
#line 531 "src/parser.yy"
                                                            { yylhs.value.as < ast::Expression * > () = new ast::Cast(ast::ident_to_record(yystack_[4].value.as < std::string > (), 2), yystack_[0].value.as < ast::Expression * > (), yystack_[5].location + yystack_[1].location); }
#line 2013 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 130: // sizeof_expr: "sizeof" "(" type ")"
#line 535 "src/parser.yy"
                                                            { yylhs.value.as < ast::Sizeof * > () = new ast::Sizeof(yystack_[1].value.as < SizedType > (), yylhs.location); }
#line 2019 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 131: // sizeof_expr: "sizeof" "(" expr ")"
#line 536 "src/parser.yy"
                                                            { yylhs.value.as < ast::Sizeof * > () = new ast::Sizeof(yystack_[1].value.as < ast::Expression * > (), yylhs.location); }
#line 2025 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 132: // offsetof_expr: "offsetof" "(" struct_type "," ident ")"
#line 540 "src/parser.yy"
                                                            { yylhs.value.as < ast::Offsetof * > () = new ast::Offsetof(yystack_[3].value.as < SizedType > (), yystack_[1].value.as < std::string > (), yylhs.location); }
#line 2031 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 133: // offsetof_expr: "offsetof" "(" expr "," ident ")"
#line 542 "src/parser.yy"
                                                            { yylhs.value.as < ast::Offsetof * > () = new ast::Offsetof(yystack_[3].value.as < ast::Expression * > (), yystack_[1].value.as < std::string > (), yylhs.location); }
#line 2037 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 134: // int: "-" "integer"
#line 546 "src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer((int64_t)(~(uint64_t)(yystack_[0].value.as < int64_t > ()) + 1), yylhs.location); }
#line 2043 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 135: // int: "integer"
#line 547 "src/parser.yy"
                             { yylhs.value.as < ast::Integer * > () = new ast::Integer(yystack_[0].value.as < int64_t > (), yylhs.location); }
#line 2049 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 136: // ident: "identifier"
#line 551 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2055 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 137: // ident: "builtin"
#line 552 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2061 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 138: // ident: "call"
#line 553 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2067 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 139: // ident: "call_builtin"
#line 554 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2073 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 140: // ident: "stack_mode"
#line 555 "src/parser.yy"
                              { yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > (); }
#line 2079 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 141: // call: "call" "(" ")"
#line 559 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 2085 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 142: // call: "call" "(" vargs ")"
#line 560 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 2091 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 143: // call: "call_builtin" "(" ")"
#line 561 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[2].value.as < std::string > (), yylhs.location); }
#line 2097 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 144: // call: "call_builtin" "(" vargs ")"
#line 562 "src/parser.yy"
                                             { yylhs.value.as < ast::Call * > () = new ast::Call(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 2103 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 145: // call: "identifier" "(" ")"
#line 563 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2109 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 146: // call: "identifier" "(" vargs ")"
#line 564 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2115 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 147: // call: "builtin" "(" ")"
#line 565 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2121 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 148: // call: "builtin" "(" vargs ")"
#line 566 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2127 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 149: // call: "stack_mode" "(" ")"
#line 567 "src/parser.yy"
                                             { error(yystack_[2].location, "Unknown function: " + yystack_[2].value.as < std::string > ()); YYERROR;  }
#line 2133 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 150: // call: "stack_mode" "(" vargs ")"
#line 568 "src/parser.yy"
                                             { error(yystack_[3].location, "Unknown function: " + yystack_[3].value.as < std::string > ()); YYERROR;  }
#line 2139 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 151: // map: "map"
#line 572 "src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2145 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 152: // map: "map" "[" vargs "]"
#line 573 "src/parser.yy"
                                  { yylhs.value.as < ast::Map * > () = new ast::Map(yystack_[3].value.as < std::string > (), yystack_[1].value.as < ast::ExpressionList * > (), yylhs.location); }
#line 2151 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 153: // var: "variable"
#line 577 "src/parser.yy"
                    { yylhs.value.as < ast::Variable * > () = new ast::Variable(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2157 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 154: // map_or_var: var
#line 581 "src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Variable * > (); }
#line 2163 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 155: // map_or_var: map
#line 582 "src/parser.yy"
                    { yylhs.value.as < ast::Expression * > () = yystack_[0].value.as < ast::Map * > (); }
#line 2169 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 156: // vargs: vargs "," expr
#line 586 "src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = yystack_[2].value.as < ast::ExpressionList * > (); yystack_[2].value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 2175 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 157: // vargs: expr
#line 587 "src/parser.yy"
                               { yylhs.value.as < ast::ExpressionList * > () = new ast::ExpressionList; yylhs.value.as < ast::ExpressionList * > ()->push_back(yystack_[0].value.as < ast::Expression * > ()); }
#line 2181 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 158: // compound_op: "<<="
#line 591 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::LEFT; }
#line 2187 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 159: // compound_op: "&="
#line 592 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BAND; }
#line 2193 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 160: // compound_op: "|="
#line 593 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BOR; }
#line 2199 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 161: // compound_op: "^="
#line 594 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::BXOR; }
#line 2205 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 162: // compound_op: "/="
#line 595 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::DIV; }
#line 2211 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 163: // compound_op: "-="
#line 596 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MINUS; }
#line 2217 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 164: // compound_op: "%="
#line 597 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MOD; }
#line 2223 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 165: // compound_op: "*="
#line 598 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::MUL; }
#line 2229 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 166: // compound_op: "+="
#line 599 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::PLUS; }
#line 2235 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;

  case 167: // compound_op: ">>="
#line 600 "src/parser.yy"
                             { yylhs.value.as < ast::Operator > () = ast::Operator::RIGHT; }
#line 2241 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"
    break;


#line 2245 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  Parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  Parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  Parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // Parser::context.
  Parser::context::context (const Parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  Parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  Parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  Parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short Parser::yypact_ninf_ = -129;

  const short Parser::yytable_ninf_ = -141;

  const short
  Parser::yypact_[] =
  {
     -32,    48,   -32,    25,  -129,   -32,   -32,  -129,  -129,    35,
    -129,    17,  -129,    12,  -129,  -129,  -129,  -129,  -129,  -129,
     494,    37,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,
    -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,
    -129,   166,    40,   -27,    40,  -129,  -129,  -129,    50,    59,
       9,    99,    18,    24,  -129,    87,  -129,  -129,    38,  -129,
    -129,     7,  -129,  -129,   494,    32,  -129,    81,    86,    91,
      93,   127,   131,   176,   235,   195,     2,  -129,  -129,  -129,
    -129,    66,  -129,  -129,  -129,    73,    82,  -129,   107,  -129,
     172,    14,    71,  -129,  -129,    33,  -129,  -129,  -129,  -129,
    -129,   207,   248,   289,   330,   371,   412,   494,   453,   494,
     101,   109,  -129,  -129,   494,   494,   494,   494,   494,   494,
     494,   494,   494,   494,   494,   494,   494,   494,   494,   494,
     494,   494,   494,  -129,  -129,  -129,  -129,   174,   181,   183,
    -129,  -129,  -129,   175,    82,   192,  -129,  -129,  -129,  -129,
     170,  -129,   516,   544,  -129,   135,   494,    75,   494,  -129,
    -129,   494,    76,   193,   202,   211,  -129,  -129,   123,  -129,
     156,  -129,   210,  -129,   212,    26,  -129,   238,   236,  -129,
    -129,  -129,   247,    86,    91,    93,   127,   131,   176,   176,
     235,   235,   235,   235,     2,     2,  -129,  -129,  -129,   195,
     195,   494,    -6,   494,  -129,  -129,    82,   494,   494,  -129,
    -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,  -129,   494,
     494,   494,   253,  -129,   494,   266,  -129,   239,  -129,  -129,
     109,   109,  -129,   494,  -129,  -129,  -129,  -129,  -129,  -129,
     494,   267,   -27,   268,   275,   279,  -129,  -129,  -129,  -129,
    -129,  -129,  -129,  -129,   494,  -129,   280,   281,  -129,  -129,
      37,    37,    37,    37,  -129,  -129,  -129,   241,  -129,  -129,
    -129,     0,  -129,  -129,  -129
  };

  const unsigned char
  Parser::yydefact_[] =
  {
       6,     0,     6,     0,    31,     6,     6,     3,     1,    31,
      14,    33,    18,    19,     4,     5,     2,    13,    16,    31,
       0,     0,    24,    28,    29,    35,    26,    27,    25,   137,
     138,   139,   136,    22,    21,    34,    23,   140,    30,    20,
      17,     0,     0,    93,     0,    90,    92,    91,     0,     0,
      65,   138,    66,    61,    63,   151,   153,   135,    64,    68,
      71,    85,    74,   125,     0,     0,    94,    95,    97,    99,
     101,   103,   105,   107,   110,   122,   115,   118,    77,    78,
      62,     0,    76,   155,   154,    69,    40,    15,     0,     7,
       0,    61,     0,     9,    10,     0,    81,    86,   134,    82,
      87,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    84,    32,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    89,    88,    79,    80,     0,     0,     0,
      48,    47,    46,     0,    40,    38,    44,    41,    42,    45,
      74,    43,   155,   154,    12,     0,     0,     0,     0,    11,
      67,     0,     0,     0,     0,     0,   147,   157,     0,   141,
       0,   143,     0,   145,     0,     0,   149,     0,     0,    83,
      72,    73,     0,    98,   100,   102,   104,   106,   108,   109,
     111,   112,   113,   114,   116,   117,   119,   120,   121,   123,
     124,     0,     0,     0,    36,    39,    40,     0,     0,   158,
     167,   166,   163,   165,   162,   164,   159,   160,   161,     0,
       0,     0,     0,   127,     0,     0,   126,     0,   130,   131,
       0,     0,   148,     0,   142,   144,   146,   152,   150,    75,
       0,     0,     0,     0,     0,     0,    37,    56,    57,    59,
      58,    60,     8,   128,     0,    70,     0,     0,   156,    96,
       0,     0,     0,     0,   129,   132,   133,    52,    50,    49,
      51,     0,    54,    55,    53
  };

  const short
  Parser::yypgoto_[] =
  {
    -129,  -129,   125,   196,  -129,   191,  -129,   287,  -129,   283,
    -129,  -129,   -11,  -110,  -128,  -129,  -129,  -129,  -129,    29,
    -129,  -129,  -129,  -129,   -83,  -129,  -129,   -19,    64,  -129,
     190,   197,   189,   199,   188,   138,    85,   132,   139,   -57,
    -129,  -129,   112,   -13,  -129,   -82,   -80,   118,   -95,   165
  };

  const short
  Parser::yydefgoto_[] =
  {
       0,     3,     4,    92,    93,    94,     9,    10,    11,    12,
      13,    21,    59,    87,   143,   144,   145,   146,   147,   148,
     274,   149,    60,    61,    62,    63,    64,   167,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,   168,   219
  };

  const short
  Parser::yytable_[] =
  {
      39,    65,    38,   150,   152,    86,   153,   112,    25,   170,
     172,   174,   175,   177,   109,    22,   205,    18,   103,    23,
      24,     1,    95,   106,   156,     8,    25,   105,   131,    96,
      19,    99,   242,   106,   237,    16,  -137,     2,    26,   233,
     132,  -136,    86,   160,   113,  -139,   161,   108,  -137,    98,
     137,  -136,    27,  -136,   157,   110,   111,  -139,    20,   101,
      28,   150,   152,  -136,   153,  -140,   227,   151,   102,    35,
      57,   196,   197,   198,    29,    30,    31,  -140,   246,    32,
      33,   158,   163,   165,    34,   224,   228,    35,    36,    37,
     178,    41,   114,   133,   107,   182,    25,   180,   181,   223,
     135,   226,    29,    30,    31,   134,   115,    32,   104,    42,
     116,   159,   136,    55,    56,   225,   159,    37,     5,     6,
      43,    44,    45,   150,   152,   151,   153,     7,    46,    47,
      14,    15,   137,   232,   138,   117,   233,   139,   118,   140,
     141,   142,    48,    49,    50,    51,    52,   120,   121,    53,
     267,   268,   269,   270,    54,    55,    56,    35,    57,    58,
      97,   272,   100,    29,    30,    31,   234,   253,    32,   233,
     119,    29,    30,    31,   154,    41,    32,   179,    37,   155,
      25,   204,   241,   201,   245,   207,    37,   151,   247,   248,
     202,   243,   203,    42,   122,   123,   206,   264,   124,   125,
     249,   250,   251,   229,    43,    44,    45,   190,   191,   192,
     193,   222,    46,    47,   258,   230,    41,   256,   257,    88,
     235,    25,   236,   233,   231,   233,    48,    49,    50,    51,
      52,    89,    90,    91,    42,   128,   129,   130,    54,    55,
      56,    35,    57,    58,   239,    43,    44,    45,   238,   255,
     240,   233,   233,    46,    47,   126,   127,    41,   188,   189,
      88,   252,    25,   199,   200,   194,   195,    48,    49,    50,
      51,    52,    89,    90,    53,    42,   254,   260,   261,    54,
      55,    56,    35,    57,    58,   262,    43,    44,    45,   263,
     265,   266,   271,   164,    46,    47,    17,   162,    41,   166,
     273,    88,    40,    25,   259,   183,   185,   187,    48,    49,
      50,    51,    52,   184,   244,    53,    42,   186,   221,     0,
      54,    55,    56,    35,    57,    58,     0,    43,    44,    45,
       0,     0,     0,     0,     0,    46,    47,     0,     0,    41,
     169,     0,     0,     0,    25,     0,     0,     0,     0,    48,
      49,    50,    51,    52,     0,     0,    53,    42,     0,     0,
       0,    54,    55,    56,    35,    57,    58,     0,    43,    44,
      45,     0,     0,     0,     0,     0,    46,    47,     0,     0,
      41,   171,     0,     0,     0,    25,     0,     0,     0,     0,
      48,    49,    50,    51,    52,     0,     0,    53,    42,     0,
       0,     0,    54,    55,    56,    35,    57,    58,     0,    43,
      44,    45,     0,     0,     0,     0,     0,    46,    47,     0,
       0,    41,   173,     0,     0,     0,    25,     0,     0,     0,
       0,    48,    49,    50,    51,    52,     0,     0,    53,    42,
       0,     0,     0,    54,    55,    56,    35,    57,    58,     0,
      43,    44,    45,     0,     0,     0,     0,     0,    46,    47,
       0,     0,    41,   176,     0,     0,     0,    25,     0,     0,
       0,     0,    48,    49,    50,    51,    52,     0,     0,    53,
      42,     0,     0,     0,    54,    55,    56,    35,    57,    58,
       0,    43,    44,    45,     0,     0,     0,     0,     0,    46,
      47,     0,     0,    41,     0,     0,     0,     0,    25,     0,
       0,     0,     0,    48,    49,    50,    51,    52,     0,     0,
      53,    42,     0,     0,     0,    54,    55,    56,    35,    57,
      58,   208,    43,    44,    45,     0,     0,     0,     0,     0,
      46,    47,     0,     0,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,    48,    49,    50,    51,    52,   220,
       0,    53,     0,     0,     0,     0,    54,    55,    56,    35,
      57,    58,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218
  };

  const short
  Parser::yycheck_[] =
  {
      13,    20,    13,    86,    86,     5,    86,    64,    14,   104,
     105,   106,   107,   108,     7,     3,   144,     0,     9,     7,
       8,    53,    41,     9,    10,     0,    14,     9,    26,    42,
      13,    44,    38,     9,     8,     0,    27,    69,    26,    13,
      38,    27,     5,    10,    12,    27,    13,     9,    39,    76,
      50,    27,    40,    39,    40,    48,    49,    39,    41,     9,
      48,   144,   144,    39,   144,    27,   161,    86,     9,    75,
      76,   128,   129,   130,    62,    63,    64,    39,   206,    67,
      68,    10,   101,   102,    72,    10,    10,    75,    76,    77,
     109,     9,    11,    27,     7,   114,    14,   110,   111,   156,
      27,   158,    62,    63,    64,    39,    25,    67,     9,    27,
      24,    40,    39,    73,    74,    40,    40,    77,    70,    71,
      38,    39,    40,   206,   206,   144,   206,     2,    46,    47,
       5,     6,    50,    10,    52,    44,    13,    55,    45,    57,
      58,    59,    60,    61,    62,    63,    64,    16,    17,    67,
     260,   261,   262,   263,    72,    73,    74,    75,    76,    77,
      42,   271,    44,    62,    63,    64,    10,   224,    67,    13,
      43,    62,    63,    64,    67,     9,    67,    76,    77,     7,
      14,     6,   201,     9,   203,    15,    77,   206,   207,   208,
       9,   202,     9,    27,    18,    19,     4,   254,    22,    23,
     219,   220,   221,    10,    38,    39,    40,   122,   123,   124,
     125,    76,    46,    47,   233,    13,     9,   230,   231,    53,
      10,    14,    10,    13,    13,    13,    60,    61,    62,    63,
      64,    65,    66,    67,    27,    40,    41,    42,    72,    73,
      74,    75,    76,    77,     8,    38,    39,    40,    10,    10,
       3,    13,    13,    46,    47,    20,    21,     9,   120,   121,
      53,     8,    14,   131,   132,   126,   127,    60,    61,    62,
      63,    64,    65,    66,    67,    27,    10,    10,    10,    72,
      73,    74,    75,    76,    77,    10,    38,    39,    40,    10,
      10,    10,    51,   102,    46,    47,     9,   101,     9,    10,
     271,    53,    19,    14,   240,   115,   117,   119,    60,    61,
      62,    63,    64,   116,   202,    67,    27,   118,   153,    -1,
      72,    73,    74,    75,    76,    77,    -1,    38,    39,    40,
      -1,    -1,    -1,    -1,    -1,    46,    47,    -1,    -1,     9,
      10,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    27,    -1,    -1,
      -1,    72,    73,    74,    75,    76,    77,    -1,    38,    39,
      40,    -1,    -1,    -1,    -1,    -1,    46,    47,    -1,    -1,
       9,    10,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    27,    -1,
      -1,    -1,    72,    73,    74,    75,    76,    77,    -1,    38,
      39,    40,    -1,    -1,    -1,    -1,    -1,    46,    47,    -1,
      -1,     9,    10,    -1,    -1,    -1,    14,    -1,    -1,    -1,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    27,
      -1,    -1,    -1,    72,    73,    74,    75,    76,    77,    -1,
      38,    39,    40,    -1,    -1,    -1,    -1,    -1,    46,    47,
      -1,    -1,     9,    10,    -1,    -1,    -1,    14,    -1,    -1,
      -1,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      27,    -1,    -1,    -1,    72,    73,    74,    75,    76,    77,
      -1,    38,    39,    40,    -1,    -1,    -1,    -1,    -1,    46,
      47,    -1,    -1,     9,    -1,    -1,    -1,    -1,    14,    -1,
      -1,    -1,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    27,    -1,    -1,    -1,    72,    73,    74,    75,    76,
      77,    15,    38,    39,    40,    -1,    -1,    -1,    -1,    -1,
      46,    47,    -1,    -1,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    60,    61,    62,    63,    64,    15,
      -1,    67,    -1,    -1,    -1,    -1,    72,    73,    74,    75,
      76,    77,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37
  };

  const signed char
  Parser::yystos_[] =
  {
       0,    53,    69,    79,    80,    70,    71,    80,     0,    84,
      85,    86,    87,    88,    80,    80,     0,    85,     0,    13,
      41,    89,     3,     7,     8,    14,    26,    40,    48,    62,
      63,    64,    67,    68,    72,    75,    76,    77,    90,   121,
      87,     9,    27,    38,    39,    40,    46,    47,    60,    61,
      62,    63,    64,    67,    72,    73,    74,    76,    77,    90,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,     5,    91,    53,    65,
      66,    67,    81,    82,    83,   105,   121,   125,    76,   121,
     125,     9,     9,     9,     9,     9,     9,     7,     9,     7,
      48,    49,   117,    12,    11,    25,    24,    44,    45,    43,
      16,    17,    18,    19,    22,    23,    20,    21,    40,    41,
      42,    26,    38,    27,    39,    27,    39,    50,    52,    55,
      57,    58,    59,    92,    93,    94,    95,    96,    97,    99,
     102,   105,   123,   124,    67,     7,    10,    40,    10,    40,
      10,    13,    81,   105,    83,   105,    10,   105,   126,    10,
     126,    10,   126,    10,   126,   126,    10,   126,   105,    76,
     121,   121,   105,   108,   109,   110,   111,   112,   113,   113,
     114,   114,   114,   114,   116,   116,   117,   117,   117,   115,
     115,     9,     9,     9,     6,    92,     4,    15,    15,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,   127,
      15,   127,    76,   117,    10,    40,   117,   126,    10,    10,
      13,    13,    10,    13,    10,    10,    10,     8,    10,     8,
       3,   105,    38,    90,   120,   105,    92,   105,   105,   105,
     105,   105,     8,   117,    10,    10,   121,   121,   105,   106,
      10,    10,    10,    10,   117,    10,    10,    91,    91,    91,
      91,    51,    91,    97,    98
  };

  const signed char
  Parser::yyr1_[] =
  {
       0,    78,    79,    80,    80,    80,    80,    81,    81,    81,
      81,    82,    83,    84,    84,    85,    85,    86,    86,    87,
      88,    88,    88,    88,    88,    88,    88,    88,    88,    88,
      88,    88,    89,    89,    90,    90,    91,    92,    92,    92,
      92,    93,    93,    94,    94,    94,    95,    95,    95,    96,
      96,    96,    97,    97,    98,    98,    99,    99,    99,    99,
      99,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     100,   101,   101,   101,   101,   101,   101,   101,   101,   101,
     101,   101,   101,   102,   103,   103,   103,   103,   103,   103,
     104,   104,   104,   104,   105,   106,   106,   107,   107,   108,
     108,   109,   109,   110,   110,   111,   111,   112,   112,   112,
     113,   113,   113,   113,   113,   114,   114,   114,   115,   115,
     115,   115,   116,   116,   116,   117,   117,   117,   117,   117,
     118,   118,   119,   119,   120,   120,   121,   121,   121,   121,
     121,   122,   122,   122,   122,   122,   122,   122,   122,   122,
     122,   123,   123,   124,   125,   125,   126,   126,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127
  };

  const signed char
  Parser::yyr2_[] =
  {
       0,     2,     3,     2,     3,     3,     0,     1,     4,     1,
       1,     2,     2,     2,     1,     3,     2,     3,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     0,     3,     0,     1,     1,     3,     3,     1,     2,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       5,     5,     5,     7,     1,     1,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       5,     1,     3,     3,     1,     4,     1,     1,     1,     2,
       2,     2,     2,     3,     2,     1,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     5,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     3,
       1,     3,     3,     3,     3,     1,     3,     3,     1,     3,
       3,     3,     1,     3,     3,     1,     4,     4,     5,     6,
       4,     4,     6,     6,     2,     1,     1,     1,     1,     1,
       1,     3,     4,     3,     4,     3,     4,     3,     4,     3,
       4,     1,     4,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const Parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\":\"", "\";\"",
  "\"{\"", "\"}\"", "\"[\"", "\"]\"", "\"(\"", "\")\"", "\"?\"",
  "\"end predicate\"", "\",\"", "\"$#\"", "\"=\"", "\"==\"", "\"!=\"",
  "\"<=\"", "\">=\"", "\"<<\"", "\">>\"", "\"<\"", "\">\"", "\"&&\"",
  "\"||\"", "\"+\"", "\"++\"", "\"<<=\"", "\">>=\"", "\"+=\"", "\"-=\"",
  "\"*=\"", "\"/=\"", "\"%=\"", "\"&=\"", "\"|=\"", "\"^=\"", "\"-\"",
  "\"--\"", "\"*\"", "\"/\"", "\"%\"", "\"&\"", "\"|\"", "\"^\"", "\"!\"",
  "\"~\"", "\".\"", "\"->\"", "\"if\"", "\"else\"", "\"unroll\"",
  "\"struct\"", "\"union\"", "\"while\"", "\"for\"", "\"return\"",
  "\"continue\"", "\"break\"", "\"sizeof\"", "\"offsetof\"", "\"builtin\"",
  "\"call\"", "\"call_builtin\"", "\"simple type\"", "\"sized type\"",
  "\"identifier\"", "\"path\"", "\"preprocessor directive\"",
  "\"struct definition\"", "\"enum\"", "\"string\"", "\"map\"",
  "\"variable\"", "\"positional parameter\"", "\"integer\"",
  "\"stack_mode\"", "$accept", "program", "c_definitions", "type",
  "pointer_type", "struct_type", "probes", "probe", "attach_points",
  "attach_point", "attach_point_def", "pred", "param", "block",
  "stmt_list", "block_stmt", "expr_stmt", "jump_stmt", "loop_stmt",
  "if_stmt", "block_or_if", "assign_stmt", "primary_expr", "postfix_expr",
  "tuple_access_expr", "unary_expr", "unary_op", "expr",
  "conditional_expr", "logical_or_expr", "logical_and_expr", "or_expr",
  "xor_expr", "and_expr", "equality_expr", "relational_expr", "shift_expr",
  "muli_expr", "addi_expr", "cast_expr", "sizeof_expr", "offsetof_expr",
  "int", "ident", "call", "map", "var", "map_or_var", "vargs",
  "compound_op", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  Parser::yyrline_[] =
  {
       0,   171,   171,   175,   176,   177,   178,   182,   212,   221,
     222,   226,   229,   233,   234,   238,   248,   261,   262,   266,
     270,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   296,   300,   301,   306,   317,   321,   328,   329,   333,
     334,   338,   339,   343,   344,   349,   353,   354,   355,   359,
     360,   361,   365,   366,   370,   371,   375,   380,   381,   382,
     387,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   414,   416,   417,   419,   421,   422,   423,   424,   425,
     426,   428,   429,   434,   440,   441,   442,   443,   445,   446,
     450,   451,   452,   453,   457,   461,   462,   467,   468,   472,
     473,   477,   478,   482,   483,   488,   489,   493,   494,   495,
     499,   500,   501,   502,   503,   507,   508,   509,   513,   514,
     515,   516,   520,   521,   522,   526,   527,   529,   530,   531,
     535,   536,   540,   542,   546,   547,   551,   552,   553,   554,
     555,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   572,   573,   577,   581,   582,   586,   587,   591,   592,
     593,   594,   595,   596,   597,   598,   599,   600
  };

  void
  Parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  Parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 4 "src/parser.yy"
} //  bpftrace 
#line 2981 "/builddir/build/BUILD/bpftrace-0.18.0/x86_64-OpenCloudOS-linux-gnu/parser.tab.cc"

#line 603 "src/parser.yy"


void bpftrace::Parser::error(const location &l, const std::string &m)
{
  driver.error(l, m);
}
